''''''''''''''''''''
'By: K.Bunch - 2008'
''''''''''''''''''''

$INCLUDE "Rapidq.inc"

$RESOURCE FolderLg AS "Images/FolderLg.bmp"
$RESOURCE FolderSm AS "Images/FolderSm.bmp"
$RESOURCE FileLg AS "Images/FileLg.bmp"
$RESOURCE FileSm AS "Images/FileSm.bmp"
$RESOURCE BackBmp AS "Images/Back.bmp"
$RESOURCE ViewBmp AS "Images/View.bmp"

DIM LgImages AS QIMAGELIST
    LgImages.Width = 32
    LgImages.Height = 32
    LgImages.AddBmpHandle(FolderLg, RGB(255, 255, 255))
    LgImages.AddBmpHandle(FileLg, RGB(255, 255, 255))
    
DIM SmImages AS QIMAGELIST
    SmImages.Width = 16
    SmImages.Height = 16
    SmImages.AddBmpHandle(FolderSm, RGB(255, 255, 255))
    SmImages.AddBmpHandle(FileSm, RGB(255, 255, 255))

DECLARE FUNCTION SetWindowLong LIB "user32" ALIAS "SetWindowLongA" (hWnd AS LONG,nIndex AS LONG, dwNewLong AS LONG) AS LONG
DECLARE FUNCTION ShellExecute LIB "shell32.dll" ALIAS "ShellExecuteA" (BYVAL hWnd AS LONG, BYVAL lpOperation AS STRING, BYVAL lpFile AS STRING, BYVAL lpParameters AS STRING, BYVAL lpDirectory AS STRING, BYVAL nShowCmd AS LONG) AS LONG

DECLARE SUB Initialize
DECLARE SUB LoadObjects
DECLARE SUB Back
DECLARE SUB ChangeViewStyle
DECLARE SUB ChangeView(Sender AS QMENUITEM)
DECLARE SUB DoubleClick
DECLARE SUB CheckPopUp
DECLARE SUB ChangeSort(Sender AS QMENUITEM)

CREATE PopUpMenu AS QPOPUPMENU
    OnPopUp = CheckPopUp
    CREATE RunItem AS QMENUITEM
        Caption = "Run"
        OnClick = DoubleClick
    END CREATE
    CREATE OpenItem AS QMENUITEM
        Caption = "Open"
        OnClick = DoubleClick
    END CREATE
    CREATE ViewItem AS QMENUITEM
        Caption = "View"
        CREATE ViewItem0 AS QMENUITEM
            Caption = "Details"
            Checked = 1
            Tag = 0
            OnClick = ChangeView
            RadioItem = 1
        END CREATE
        CREATE ViewItem1 AS QMENUITEM
            Caption = "List"
            Tag = 1
            OnClick = ChangeView
            RadioItem = 1
        END CREATE
        CREATE ViewItem2 AS QMENUITEM
            Caption = "Icons"
            Tag = 2
            OnClick = ChangeView
            RadioItem = 1
        END CREATE
    END CREATE
    CREATE BlankItem0 AS QMENUITEM
        Caption = "-"
    END CREATE
    CREATE SortItem AS QMENUITEM
        Caption = "Sort by.."
        CREATE SortItem0 AS QMENUITEM
            Caption = "Name"
            Checked = 1
            RadioItem = 1
            Tag = 0
            OnClick = ChangeSort
        END CREATE
        CREATE SortItem1 AS QMENUITEM
            Caption = "Type"
            RadioItem = 1
            Tag = 1
            OnClick = ChangeSort
        END CREATE
    END CREATE
    CREATE BlankItem1 AS QMENUITEM
        Caption = "-"
    END CREATE
    CREATE RefreshItem AS QMENUITEM
        Caption = "Refresh"
        OnClick = LoadObjects
    END CREATE
END CREATE

CREATE Form AS QFORM
    Caption = "Custom File List Box"
    Width = 500
    Height = 400
    BorderStyle = 3
    Center
    OnShow = Initialize
    ShowHint = 1
    CREATE BtnPanel AS QPANEL
        Align = alTop
        Height = 25
        CREATE BackBtn AS QCOOLBTN
            Top = 1
            Left = 1
            Width = 23
            Height = 23
            Hint = "Back"
            OnClick = Back
            BmpHandle = BackBmp
        END CREATE
        CREATE ViewBtn AS QCOOLBTN
            Top = 1
            Left = BackBtn.Left + BackBtn.Width
            Width = 23
            Height = 23
            Hint = "View Style"
            BmpHandle = ViewBmp
            OnClick = ChangeViewStyle
        END CREATE
    END CREATE
    CREATE Lv AS QLISTVIEW
        Align = alClient
        ViewStyle = vsReport
        AddColumns "Name", "Size", "Date"
        Column(0).Width = 200
        Column(1).Width = 100
        Column(2).Width = 100
        SmallImages = SmImages
        LargeImages = LgImages
        OnDblClick = DoubleClick
        PopUpMenu = PopUpMenu
    END CREATE
    CREATE List AS QLISTBOX
        Align = alRight
        Width = 300
        Visible = 0
    END CREATE
    CREATE Sb AS QSTATUSBAR
        Align = alBottom
        Height = 25
        AddPanels ""
    END CREATE
END CREATE

DEFINT Amount0 = 0
DEFINT Vs = 0
DEFINT St = 2
DEFSTR Obj = ""
DEFSTR Dir = Command$(0)-Application.Exename

SetWindowLong(Form.Handle, -8, 0)
SetWindowLong(Application.Handle, -8, Form.Handle)

Form.ShowModal

SUB ChangeSort(Sender AS QMENUITEM)
    SELECT CASE Sender.Tag
        CASE 0
            St = 2
        CASE 1
            St = 0
    END SELECT
    LoadObjects
    Sender.Checked = 1
END SUB

SUB CheckPopUp
    IF Lv.ItemIndex = -1 THEN
        RunItem.Visible = 0
        OpenItem.Visible = 0
        ViewItem.Visible = 1
        BlankItem0.Visible = 1
        SortItem.Visible = 1
        BlankItem1.Visible = 1
        RefreshItem.Visible = 1
    ELSE
        IF Lv.Item(Lv.ItemIndex).ImageIndex = 0 THEN
            RunItem.Visible = 0
            OpenItem.Visible = 1
        ELSE
            RunItem.Visible = 1
            OpenItem.Visible = 0
        END IF
        ViewItem.Visible = 0
        BlankItem0.Visible = 0
        SortItem.Visible = 0
        BlankItem1.Visible = 0
        RefreshItem.Visible = 0
    END IF
END SUB

SUB DoubleClick
    DEFINT RetVal
    IF Lv.ItemIndex = -1 THEN EXIT SUB
    IF Lv.Item(Lv.ItemIndex).ImageIndex = 0 THEN
        CHDIR = curdir$ + "\" + Lv.Item(Lv.ItemIndex).Caption
        LoadObjects
    ELSE
        RetVal = ShellExecute(Form.Handle, "Open", Lv.Item(Lv.ItemIndex).Caption, "", "", 1)
    END IF
END SUB

SUB ChangeView(Sender AS QMENUITEM)
    SELECT CASE Sender.Tag
        CASE 0
            Vs = 0
            Lv.ViewStyle = vsReport
        CASE 1
            Vs = 1
            Lv.ViewStyle = vsSmallIcon
        CASE 2
            Vs = 2
            Lv.ViewStyle = vsIcon
    END SELECT
    
    Sender.Checked = 1
END SUB

SUB ChangeViewStyle
    SELECT CASE Vs
        CASE 0
            Vs = 1
            Lv.ViewStyle = vsSmallIcon
        CASE 1
            Vs = 2
            Lv.ViewStyle = vsIcon
        CASE 2
            Vs = 0
            Lv.ViewStyle = vsReport
    END SELECT
END SUB

SUB Back
    CHDIR("..")
    LoadObjects
END SUB

SUB LoadObjects
    Sb.Panel(0).Caption = CURDIR$
    Lv.Clear
    List.Clear
    Lv.SortType = St
    Obj = DIR$("*.*", &H3F)
    
    IF Obj <> "" THEN
        IF Obj <> "." AND Obj <> ".." THEN
            IF DirExists(obj) THEN
                List.AddItems "0" + Obj
            ELSE
                List.AddItems "1" + Obj
            END IF
        END IF
        DO
            Obj = DIR$
            IF Obj <> "" THEN
                IF Obj <> "." AND Obj <> ".." THEN
                    IF DirExists(Obj) THEN
                        List.AddItems "0" + Obj
                    ELSE
                        List.AddItems "1" + Obj
                    END IF
                END IF
            ELSE
                EXIT DO
            END IF
        LOOP UNTIL Obj = ""
    END IF
    
    IF St = 2 THEN
        FOR Amount0 = 0 TO List.ItemCount-1
            Lv.AddItems DIR$(DELETE$(List.Item(Amount0), 1, 1), &h3F)
            IF MID$(List.Item(Amount0), 1, 1) = "0" THEN
                Lv.Item(Amount0).ImageIndex = 0
                Lv.AddSubItem(Amount0, "")
            ELSE
                Lv.Item(Amount0).ImageIndex = 1
                Lv.AddSubItem(Amount0, STR$(FileRec.Size) + " byte(s)")
            END IF
            Lv.AddSubItem(Amount0, FileRec.Date)
        NEXT Amount0
    ELSE
        FOR Amount0 = 0 TO List.ItemCount-1
            IF MID$(List.Item(Amount0), 1, 1) = "0" THEN
                Lv.AddItems(DIR$(DELETE$(List.Item(Amount0), 1, 1), &h3F))
                Lv.Item(Lv.ItemCount-1).ImageIndex = 0
                Lv.AddSubItem(Lv.ItemCount-1, "")
                Lv.AddSubItem(Lv.ItemCount-1, FileRec.Date)
            END IF
        NEXT Amount0
        FOR Amount0 = 0 TO List.ItemCount-1
            IF MID$(List.Item(Amount0), 1, 1) = "1" THEN
                Lv.AddItems(DIR$(DELETE$(List.Item(Amount0), 1, 1), &h3F))
                Lv.Item(Lv.ItemCount-1).ImageIndex = 1
                Lv.AddSubItem(Lv.ItemCount-1, STR$(FileRec.Size) + " byte(s)")
                Lv.AddSubItem(Lv.ItemCount-1, FileRec.Date)
            END IF
        NEXT Amount0
    END IF    
END SUB

SUB Initialize
    LoadObjects
END SUB


